-- v1.15b

-- true = ON, false = OFF

local mythicraid =        true -- 20-player Mythic Raid
local heroicraid =        true -- 10-30-player Heroic Raid
local normalraid =        true -- 10-30-player Normal Raid
local lookforraid =      false -- 10-30-player Raid Finder
local mythicplus =        true -- 5-player Mythic+ Dungeon
local mythicdungeon =    false -- 5-player Mythic Dungeon
local heroicdungeon =    false -- 5-player Heroic Dungeon
local normaldungeon =    false -- 5-player Dungeon
local timewalker =       false -- 5-player Timewalker Dungeon
local scenario =         false -- Scenario, Proving Grounds
local legacy =           false -- Legacy Raids

local alwayson =         false -- Always ON no-matter where or when

local Announce =          true -- Announce in chat for on and off

-- 

local Debug = false


local function ann(msg)
	if (Announce) then
		ChatFrame1:AddMessage(msg)
	end
end

local function debug(msg)
	if (Debug) then
		ChatFrame1:AddMessage(msg)
	end
end

SlashCombatLogDB = SlashCombatLogDB or {}
SlashCombatLogDB.logging = SlashCombatLogDB.logging or {}

local OnLoadFrame = CreateFrame("Frame")
OnLoadFrame:RegisterEvent("ADDON_LOADED"); 
OnLoadFrame:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		debug("SlashCombatLog loaded")
		SlashCombatLogDB.logging = SlashCombatLogDB.logging or {}
		SlashCombatLogDB.loaded = SlashCombatLogDB.loaded or {}			
		if 	SlashCombatLogDB.logging == true then
			LoggingCombat(true)
			debug("/combatlog ON")
		else
			debug("/combatlog OFF")
		end
	end
end)

local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("CHALLENGE_MODE_START","ZONE_CHANGED_NEW_AREA")
EventFrame:SetScript("OnEvent", function(self, event, ...)
	local name, type, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance, mapID, instanceGroupSize = GetInstanceInfo()
	if (alwayson) then
	-- Always ON
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Always on set, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
    elseif (mythicplus) and event == "CHALLENGE_MODE_START" then
	-- 8 - Challenge Mode Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-player Mythic+ Dungeon, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (mythicraid) and type == "raid" and difficulty == 16 then
	-- 16 - 20-player Mythic Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Mythic Raid, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (heroicraid) and type == "raid" and difficulty == 15 then
	-- 15 - 10-30-player Heroic Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Heroic Raid, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (normalraid) and type == "raid" and difficulty == 14 then
	-- 14 - 10-30-player Normal Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Normal Raid, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (lookforraid) and type == "raid" and difficulty == 17 then
	-- 17 - 10-30-player Raid Finder Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Raid Finder, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (normaldungeon) and type == "party" and difficulty == 1 and maxPlayers == 5 then
	-- 1 - 5-player Instance, filtering Garrison
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-man Normal Dungeon, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (heroicdungeon) and type == "party" and difficulty == 2 and maxPlayers == 5 then
	-- 2 - 5-player Heroic Instance, filtering Garrison
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-man Heroic Dungeon, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (mythicdungeon) and type == "party" and difficulty == 23 and maxPlayers == 5 then
	-- 23 - Mythic 5-player Instance, filtering Garrison
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-man Mythic Dungeon, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (timewalker) and type == "party" and difficulty == 24 and maxPlayers == 5 then
	-- 24 - Timewalker 5-player Instance, filtering Garrison
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("5-man Timewalker Dungeon, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (scenario) and type == "scenario" then
	-- Scenario by type
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Scenario, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	elseif (legacy) and type == "raid" and (difficulty == 3 or difficulty == 4 or difficulty == 5 or difficulty == 6 or difficulty == 7 or difficulty == 9) then
	-- 3 - 10-player Raid Instance
	-- 4 - 25-player Raid Instance
	-- 5 - 10-player Heroic Raid Instance
	-- 6 - 25-player Heroic Raid Instance
	-- 7 - 25-player Raid Finder Instance
	-- 9 - 40-player Raid Instance
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
		ann("Legacy Raids, /combatlog ON")
		LoggingCombat(true)
		SlashCombatLogDB.logging = true
	else
		debug("InstanceInfo: "..name..","..type..","..difficulty..","..difficultyName..","..maxPlayers..","..playerDifficulty..","..mapID..","..instanceGroupSize)
--		ann("/combatlog OFF")
		LoggingCombat(false)
		SlashCombatLogDB.logging = false
	end
end)